/*
 * pettanR system.js
 *   version 0.4.11
 *   
 * author:
 *   itozyun
 * licence:
 *   3-clause BSD
 */


pettanr.log = ( function(){
	return {
		init: function(){}
	}
})();

pettanr.io = ( function(){
	
	return {
		init: function(){}
	}
})();

/*
 * 画像一覧は
 * 	お気に入り画像一覧 > tag:ペン次郎 > ペン次郎：笑う
 *  最近アップロードされた画像 > images
 *  最近使われた画像 > images
 *  キャラクター画像庫 > アニマル系 > tag:ペン次郎 > ペン次郎：笑う
 *  風景画像庫 >
 *  効果画像庫 >
 *  アイテム画像庫 >
 *  
 * 画像一覧を読み込むタイミング
 */
pettanr.file = ( function(){
	var FILE_TYPE_IS_FOLDER = 1,
		numFileType = FILE_TYPE_IS_FOLDER,
		FILEDATA_RESITER = [],			// store all of fileData( json object )
		FILEDATA_ACCESS = [],			// file operations for Kernel only ! hide from Out of pettanr.file
		FILE_OBJECT_POOL = [],
		EVENT_LISTENER_RESISTER = [],
		TREE_ARRAY = [],
		TREE_ACCESS_ARRAY = [];
	
	var REQUEST_CONTROLER = ( function(){
		var REQUEST_TICKET_RESISTER = [],
			DATA_TYPE_ARRAY = 'json,xml,html,text'.split( ','),
			DATA_IS_JSON = 0,
			DATA_IS_XML = 1,
			DATA_IS_HTML = 2,
			DATA_IS_TEXT = 3,
			numError = 0;
		
		var RequestTicketClass = function( _type, _data, _url, _onLoad, _onError){
			this.type = DATA_TYPE_ARRAY[ _type];
			this.data = _data;
			this.url = _url;
			this.onLoad = _onLoad;
			this.onError = _onError;
			this.state = 0;
		};
		
		function request(){
			if( REQUEST_TICKET_RESISTER.length === 0) return;
			var _ticket = REQUEST_TICKET_RESISTER.shift();
			$.ajax({
				url:		_ticket.url,
				dataType:	_ticket.type,
				success:	function( _data){
					_ticket.onLoad( _ticket.data, _data);
				},
				error: 		function(){
					++numError;
					_ticket.onError( _ticket.data);
				}
			});
		}
		
		return {
			getNumTask: function(){
				return REQUEST_TICKET_RESISTER.length;
			},
			getNumError: function(){
				return numError;
			},
			getJson: function( _data, _url, _onLoad, _onError){
				REQUEST_TICKET_RESISTER.push( new RequestTicketClass( DATA_IS_JSON, _data, _url, _onLoad, _onError));
				request();
			}
		}
	})();



	var FILE_CONTROLER = {
		createTree: function( _rootFileData){
			var _tree = new TreeClass( _rootFileData);
			_tree.init();
			TREE_ARRAY.push( _tree);
			return _tree;
		},
		getFileDataAccess: function( UIDorFILEorFILEDATA){
			var _uid, _data, _access;
			
			if( typeof UIDorFILEorFILEDATA === 'number'){
				_data = FILEDATA_RESITER[ UIDorFILEorFILEDATA] || null;
			} else
			if( UIDorFILEorFILEDATA instanceof FileClass){
				_uid = UIDorFILEorFILEDATA.getUID();
				_data = FILEDATA_RESITER[ _uid] || null;
			} else {
				_data = UIDorFILEorFILEDATA || null;
			}
			
			if( _data === null || typeof _data !== 'object') return null;
			for( var i=0, l = FILEDATA_ACCESS.length; i<l; ++i){
				_access = FILEDATA_ACCESS[ i];
				if( _access.DATA === _data) return _access;
			}
			return null;
		},		
		getFileData: function( UIDorFILEorFILEDATA){
			var _access = FILE_CONTROLER.getFileDataAccess( UIDorFILEorFILEDATA);
			return _access !== null ? _access.DATA : null;
		},
		getChildren: function( UIDorFILEorFILEDATA){
			var _data = FILE_CONTROLER.getFileData( UIDorFILEorFILEDATA);
			return _data !== null ? _data.children || null : null;
		},
		getDriver: function( _file){
			var _data = FILE_CONTROLER.getFileData( _file);
			return _data !== null && _data.driver ? _data.driver : FileDriverBase;
		},
		getUpdateFlag: function( _file, _bit){
			var _driver = FILE_CONTROLER.getDriver( _file ),
				_policy;
			if( typeof _driver.getUpdatePolicy === 'function'){
				_policy = _driver.getUpdatePolicy( _file );
				
			}
			if( typeof _policy !== 'number') {
				_policy = FileDriverBase.getUpdatePolicy( _file )
			}
			return _policy % ( _bit * 2) >= _bit;
		},
		move: function( _prentUID, _targetfile, _newFolder, _newIndex, _opt_callback){
			var _parentData = FILE_CONTROLER.getFileDataAccess( _prentUID),
				_parentType = _parentData.TYPE,
				_targetData = FILE_CONTROLER.getFileDataAccess( _targetfile),
				_targetType = _targetData.TYPE;
		},
		replace: function( _uid, _file, _newIndex){
			
		},
		addEventListener: function( FILEorNULL, _eventType, _callback){
			var _uid = FILEorNULL instanceof FileClass ? FILEorNULL.getUID() : FILEorNULL;
			EVENT_LISTENER_RESISTER.push( new FileEventTicketClass( _uid, _eventType, _callback));
		},
		removeEventListener: function( FILEorNULL, _eventType, _callback){
			var _uid = FILEorNULL instanceof FileClass ? FILEorNULL.getUID() : FILEorNULL,
				_ticket;
			for(var i=0, l = EVENT_LISTENER_RESISTER.length; i<l; ++i){
				_ticket = EVENT_LISTENER_RESISTER[i];
				if( _ticket.fileUID === _uid && _ticket.eventType === _eventType && _ticket.callBack === _callback){
					EVENT_LISTENER_RESISTER.splice( i, 1);
					_ticket.destroy();
				}
			}
		},
		fileEventRellay: function( _targetFile, _targetTree, _event){
			var _uid = _targetTree.getUID(),
				_access = TREE_ACCESS_ARRAY[ _uid ],
				_data = FILE_CONTROLER.getFileData( _targetFile ),
				_tree;
			_access && _access.dispatchFileEvent( _event );
			for( var i=0, l = TREE_ARRAY.length; i<l; ++i){
				if( i !== _uid){
					_tree = TREE_ARRAY[ i ];
					if( FILE_CONTROLER.getFileData( _tree.getCurrentFile() ) === _data ){
						_access = TREE_ACCESS_ARRAY[ _tree.getUID() ];
						_access && _access.dispatchFileEvent( _event);
					}
				}
			}
		}
	}

	var TreeClass = function( ROOTFILE_DATA){
		var UID = TREE_ACCESS_ARRAY.length,
			PARENT_FILE_RESITER = [],
			ACCESS = {
				dispatchFileEvent:	dispatchFileEvent,
				destroy:			onDestroy
			},
			EVENT_LISTENER_ARRAY = [],
			rootFile,
			rootFileData,
			currentFile,
			currentFileData,
			instance;
			
		TREE_ACCESS_ARRAY.push( ACCESS);
		
		function onDestroy(){
			
		}
		
		function dispatchFileEvent( e){
			var _eventType = e.eventType,
				_targetFile = e.targetFile,
				_uid = _targetFile.getUID(),
				_ticket, _type, _callback;
			for(var i=0, l = EVENT_LISTENER_RESISTER.length; i<l; ++i){
				_ticket = EVENT_LISTENER_RESISTER[i],
				_type = _ticket.eventType,
				_callback = _ticket.callBack;
				if( _eventType === _type && _uid === _ticket.fileUID){
					_callback( _eventType, _targetFile, e.key, e.value);
				} else
				if( _type === pettanr.file.TREE_EVENT.UPDATE && _eventType === pettanr.file.FILE_EVENT.GET_SEQENTIAL_FILES){
					_callback( _eventType, _targetFile);
				}
			}
		}
		
		return {
			init: function(){
				instance = this;
				currentFile = rootFile = new FileClass( this, null, ROOTFILE_DATA);
				// rootFile.init();
				currentFile.getSeqentialFiles();
				delete this.init;
			},
			getUID: function(){ return UID},
			getRootFile : function(){
				return rootFile;
			},
			getCurrentFile: function(){
				return currentFile;
			},
			hierarchy: function(){
				return PARENT_FILE_RESITER.length;
			},
			getParentFileAt: function( _index){
				var l = PARENT_FILE_RESITER.length;
				if( typeof _index !== 'number' || _index < 0 || _index >= l) return null;
				return PARENT_FILE_RESITER[ l -1 -_index];
			},
			down: function( _index){
				if( typeof _index !== 'number' || _index < 0 || _index >= currentFile.getChildFileLength()) return;
				PARENT_FILE_RESITER.unshift( currentFile);
				currentFile = currentFile.getChildFileByIndex( _index);
				currentFile.getSeqentialFiles();
				return currentFile;
			},
			up: function( _index){
				var l = PARENT_FILE_RESITER.length;
				if( l === 0) return null;
				if( typeof _index === 'number'){
					if( _index >= l) return null;
					currentFile = this.getParentFileAt( _index);
					PARENT_FILE_RESITER.splice( 0, l -_index);
				} else {
					currentFile = PARENT_FILE_RESITER.shift();
				}
				currentFile.getSeqentialFiles();
				return currentFile;	
			},
			addTreeEventListener: function( _eventType, _callback){
				FILE_CONTROLER.addEventListener( null, _eventType, _callback);
			},
			removeTreeEventListener: function( _eventType, _callback){
				FILE_CONTROLER.removeEventListener( null, _eventType, _callback);
			},
			destroy: function(){
				FILE_CONTROLER.destroyTree( UID);
			}
		}
	};

	var FileEventTicketClass = function( UID, _eventType, _callback){
		this.fileUID = UID;
		this.eventType = _eventType;
		this.callBack = _callback;
		this.destroy = function(){
			this.callBack = _callback = null;
		}
	}
	
	var FileEventClass = function( eventType, file, key, value){
		this.eventType = eventType;
		this.targetFile = file;
		this.updatedAttribute = key;
		this.updatedValue = value;
	}

/*
 * fileのdataはobjectで保持している。
 * pettanr.file.の外からファイルをみるときは、FileClassを通して操作する。
 * fileの変更、それに付随して追加されたイベントは、TreeClassで管理される。
 * treeがdestryされると、fileのイベントリスナーも全て削除される。
 * 他の tree も data の共通する currentFile に対してのみは、file の変更イベントを受け取って流す．
 */
	
	var FileClass = function( TREE, parentFile, data){
		var uid = pettanr.util.getIndex( FILEDATA_RESITER, data ),
			instance = this;
		
		if( uid === -1){
			uid = FILEDATA_RESITER.length;
			FILEDATA_RESITER.push( data );
		}
		
		FILEDATA_ACCESS.push(
			{
				DATA:				data,
				updateParent:		updateParent,
				dispatchFileEvent:	dispatchEvent
			}
		);

		function updateParent( _parent){
			parentFile = _parent;
		}
		function dispatchEvent( e){
			FILE_CONTROLER.fileEventRellay( instance, TREE, e);
		}
		
		/* grobal Methods */

		this.getUID = function(){
			return uid;
		}
		/*
		 * ファイル構造は TRON のような ハイパーリンク方式 だが、文脈上の 親ファイルが存在する．その親ファイルを使う操作は.prototype に置く事ができない．
		 * 同様に TREE を使う操作も .prototype に置く事ができない．
		 */
		this.getChildFileByIndex = function( _index){
			var _children = FILE_CONTROLER.getChildren( instance );
			if( typeof _index !== 'number' || _index < 0 || typeof _children.length !== 'number' || _index >= _children.length) return null;
			var _file = new FileClass( TREE, this, _children[ _index]);
			// _file.init();
			return _file;
		}
		this.move = function( _newFolder, _newIndex, opt_callback){
			TREE.move( parentFile, UID, _newFolder, _newIndex, opt_callback);
		}
		this.replace = function( _newIndex, opt_callback){
			TREE.replace( parentFile, UID, _newIndex, opt_callback);
		}
		this.destroy = function(){
			var _access = FILE_CONTROLER.getFileDataAccess( instance );
				_index = getChildIndex( FILEDATA_ACCESS, _access );
			if( _index === -1 || _access === null) return;
			FILEDATA_ACCESS.splice( _index, 1);
			TREE = parentFile = data = null;
			delete _access.DATA, _access.updateParent, _access.dispatchFileEvent;
		}
	};
	
	FileClass.prototype = {
		isChildFile: function( _FILEorFILEDATA){
			return this.getChildFileIndex( _FILEorFILEDATA) !== -1;
		},
		getSeqentialFiles: function(){
			var _driver = FILE_CONTROLER.getDriver( this );
			if( _driver !== null && typeof _driver.getSeqentialFiles === 'function'){
				_driver.getSeqentialFiles( this );
			}
		},
		addEventListener: function( _eventType, _callback){
			FILE_CONTROLER.addEventListener( this, _eventType, _callback);
		},
		removeEventListener: function( _eventType, _callback){
			FILE_CONTROLER.removeEventListener( this, _eventType, _callback);
		},
		getChildFileLength: function(){
			var children = FILE_CONTROLER.getChildren( this);
			return Type.isArray( children ) === true ? children.length : -1;
		},
		getChildFileIndex: function( _FILEorFILEDATA){
			var children = FILE_CONTROLER.getChildren( this);
			if( Type.isArray( children.length ) === false ) return -1;
			var l = children.length,
				_fileData = FILE_CONTROLER.getFileData( _FILEorFILEDATA);
			if( _fileData === null) return -1;
			for(var i=0; i<l; ++i){
				if( children[ i] === _fileData) return i;
			}
			return -1;
		},
		getName: function(){
			var driver = FILE_CONTROLER.getDriver( this );
			if( typeof driver.getName === 'function'){
				return driver.getName( this );
			}
			return FileDriverBase.getName( this);
		},
		getThumbnail: function(){
			var driver = FILE_CONTROLER.getDriver( this);
			if( typeof driver.getThumbnail === 'function'){
				return driver.getThumbnail( this);
			}
			return FileDriverBase.getThumbnail( this);
		},
		getType: function(){
			var _data = FILE_CONTROLER.getFileData( this);
			return typeof _data.type === 'number' ? _data.type : pettanr.file.FILE_TYPE.UNKNOWN;
		},
		getState: function(){
			var _data = FILE_CONTROLER.getFileData( this);
			return typeof _data.state === 'number' ? _data.state : pettanr.file.FILE_STATE.OK;
		},
		isWritable: function(){
			return FILE_CONTROLER.getUpdateFlag( this, pettanr.file.FILE_UPDATE_POLICY.WRITE);
		},
		isSortable: function(){
			return FILE_CONTROLER.getUpdateFlag( this, pettanr.file.FILE_UPDATE_POLICY.SORT);
		},		
		isCreatable: function(){
			return FILE_CONTROLER.getUpdateFlag( this, pettanr.file.FILE_UPDATE_POLICY.CREATE);
		},
		isRenamable: function(){
			return FILE_CONTROLER.getUpdateFlag( this, pettanr.file.FILE_UPDATE_POLICY.RENAME);
		},
		read: function(){
			// simpleDeepCopy
			return false;
		},
		write: function( _newName, _newData){
			return false;
		},
		viwerApps: function(){
			
		},
		editorApps: function(){
			
		},
		create: function(){
			
		},
		sort: function(){
			
		},
		onCopy: function(){
			
		},
		onDelete: function(){
			
		}
	}

	/*
	 * FileDriverBase
	 */
	var FileDriverBase = {
		getSeqentialFiles: function( _file){
		},
		getName: function( _file){
			var _data = FILE_CONTROLER.getFileData( _file);
			return _data.name || 'No Name';
		},
		getThumbnail: function( _file){
			var _data = FILE_CONTROLER.getFileData( _file);
				_type = _data.type,
				_className = '';
			if( _type === pettanr.file.FILE_TYPE.FOLDER){
				_className = 'folder';
			} else
			if( _type === pettanr.file.FILE_TYPE.IMAGE){
				
			} else
			if( _type === pettanr.file.FILE_TYPE.TEXT){
				
			} else
			if( _type === pettanr.file.FILE_TYPE.HTML){
				
			} else
			if( _type === pettanr.file.FILE_TYPE.CSV){
				
			} else
			if( _type === pettanr.file.FILE_TYPE.JSON){
				
			} else
			if( _type === pettanr.file.FILE_TYPE.XML){
				
			}
			return {
				image:		null,
				className:	' file-type-' + _className
			}
		},
		getUpdatePolicy: function( _file){
			// debug用 全てのメニューを許可
			return pettanr.file.FILE_UPDATE_POLICY.SRWC;
		},
		read: function(){
			return false;
		},
		write: function( _newName, _newData){
			return false;
		},
		onCreate: function(){
			
		},
		onSort: function(){
			
		},
		onCopy: function(){
			
		},
		onDelete: function(){
			
		}
	}

	var ROOT_FILEDATA = {
			name: 		'system root',
			type:		FILE_TYPE_IS_FOLDER,
			children:	[]
		},
		SYSTEM_TREE = FILE_CONTROLER.createTree( ROOT_FILEDATA),
		ROOT_FILE = SYSTEM_TREE.getRootFile();
	
	function createFolderUnderRoot( _fileData){
		ROOT_FILEDATA.children.push( _fileData);
		FILE_CONTROLER.getFileDataAccess( ROOT_FILE)
			.dispatchFileEvent( new FileEventClass( pettanr.file.FILE_EVENT.GET_SEQENTIAL_FILES, ROOT_FILE, 'children', null));
	}
	function createFileEvent( _eventType, _file, _key, _value){
		return new FileEventClass( _eventType, _file, _key, _value)
	}
	function createFileTypeID(){
		return ++numFileType;
	}
	
	return {
		init: function(){
			//REQUEST_CONTROLER.init();
			//FILE_CONTROLER.init();
			delete pettanr.file.init;
		},
		resisterDriver: function( _driver){
			_driver.prototype = FileDriverBase;
			/*
			 * File API
			 */
			return {
				createFolderUnderRoot:	createFolderUnderRoot,
				getFileDataAccess:		FILE_CONTROLER.getFileDataAccess,
				getFileData:			FILE_CONTROLER.getFileData,
				getJson:				REQUEST_CONTROLER.getJson,
				createFileEvent:		createFileEvent,
				createFileTypeID:		createFileTypeID
			}
		},
		createTree: function( _rootFile){
			return FILE_CONTROLER.createTree( _rootFile);
		},
		isTreeInstance: function( _tree){
			return _tree instanceof TreeClass;
		},
		isFileInstance: function( _file){
			return _file instanceof FileClass;
		},
		FILE_TYPE: {
			UNKNOWN:	0,
			FOLDER:		FILE_TYPE_IS_FOLDER,
			IMAGE:		createFileTypeID(),
			TEXT:		createFileTypeID(),
			HTML:		createFileTypeID(),
			CSV:		createFileTypeID(),
			JSON:		createFileTypeID(),
			XML:		createFileTypeID()
		},
		FILE_STATE: {
			UNKNOWN:	0,
			OK:			1,
			LOADING:	2,
			ERROR:		3,
			BROKEN:		4
		},
		FILE_UPDATE_POLICY: {
			____:		parseInt( '0000', 2),
			___C:		parseInt( '0001', 2), // hasCreateMenu
			__W_:		parseInt( '0010', 2), // isWritable
			__WC:		parseInt( '0011', 2), // isWritable
			_R__:		parseInt( '0000', 2), // isRenamable
			_R_C:		parseInt( '0101', 2), // hasCreateMenu
			_RW_:		parseInt( '0110', 2), // isWritable
			_RWC:		parseInt( '0111', 2), // isWritable
			S___:		parseInt( '1000', 2), // childrenIsSortable
			S__C:		parseInt( '1001', 2),
			S_W_:		parseInt( '1010', 2),
			S_WC:		parseInt( '1011', 2),
			SR__:		parseInt( '1000', 2),
			SR_C:		parseInt( '1101', 2),
			SRW_:		parseInt( '1110', 2),
			SRWC:		parseInt( '1111', 2),
			CREATE:		1,
			WRAITE:		2,
			RENAME:		4,
			SORT:		8
		},
		TREE_EVENT: {
			UPDATE:				'onTreeUpdate'
		},
		FILE_EVENT: {
			UPDATE_ATTRIVUTE:	'onFileUpdate',
			GET_SEQENTIAL_FILES:'gotSeqentilFiles'
		},
		FILE_DATA_PROPERTY_RESERVED: [
			'children', 'driver', 'state', 'type'
		]
	}
})();

pettanr.finder = ( function(){
	var FINDER_ARRAY = [],
		ELM_ORIGIN_FINDER_LOCATION_ITEM = pettanr.util.pullHtmlAsTemplete( 'templete-finder-location-item'),
		ELM_ORIGIN_FINDER_ICON = pettanr.util.pullHtmlAsTemplete( 'templete-finder-icon'),
		ELM_ORIGIN_CONTAINER = pettanr.util.pullHtmlAsTemplete( 'templete-finder-container'),
		ICON_HEIGHT = pettanr.util.getElementSize( ELM_ORIGIN_FINDER_ICON).height,
		ICON_CLASSNAME = ELM_ORIGIN_FINDER_ICON.getElementsByTagName( 'div')[0].className,
		FINDER_ICON_POOL = [],
		BREAD_OBJECT_POOL = [];
	
	var FinderIconClass = function(){
		var elmContainer,
			ELM_WRAPPER = ELM_ORIGIN_FINDER_ICON.cloneNode( true),
			ELM_THUMBNAIL = pettanr.util.getElementsByClassName( ELM_WRAPPER, 'finder-icon-thumbnail', 'div')[0],
			ELM_FILENAME = pettanr.util.getElementsByClassName( ELM_WRAPPER, 'finder-icon-filename', 'div')[0],
			file, w, index, style, instansce, callback;
		
		ELM_WRAPPER.onclick = onClick;
		function onClick(){
			callback( index);
		}

		function draw(){
			var _thumb = file.getThumbnail();
			if( _thumb.image){
				ELM_THUMBNAIL.className = ICON_CLASSNAME + ' has-thumbnail';
				ELM_THUMBNAIL.style.backgroundImage = [ 'url(', _thumb.image, ')'].join( '');
			} else {
				ELM_THUMBNAIL.className = ICON_CLASSNAME + ' ' +_thumb.className;
				ELM_THUMBNAIL.style.backgroundImage = '';
			}
			ELM_FILENAME.innerHTML = file.getName();
		}
		function resize(){
			ELM_WRAPPER.style.top = (index * ICON_HEIGHT) +'px';
		}
		function onCollect(){
			elmContainer.removeChild( ELM_WRAPPER);
			elmContainer = null;
			FINDER_ICON_POOL.push( instansce);
		}
		
		return {
			init: function( _file, _elmContainer, _w, _index, _style, _callback){
				instansce = this;
				if( elmContainer !== _elmContainer){
					_elmContainer.appendChild( ELM_WRAPPER);
					elmContainer = _elmContainer;
				}
				if( file !== _file){
					file = _file;
					draw();
				}
				if( index !== _index){
					index = _index;
					resize();
				}
				callback = _callback;
			},
			elm: ELM_WRAPPER,
			index: function( _index){
				
				return index;
			},
			style: function( _style){
				
				return style;
			},
			onResize: function( w){
				
			},
			destroy: function(){
				elmContainer.removeChild( ELM_WRAPPER);
				file = elmContainer = null;
				FINDER_ICON_POOL.push( instansce);
			}
		}
	}
	function updateIconPosition( _style, _w, _index, _elm){
		
	}
	var BreadcrumbClass = function(){
		var elmContainer,
			ELM_WRAPPER = ELM_ORIGIN_FINDER_LOCATION_ITEM.cloneNode( true),
			ELM_FILENAME = ELM_WRAPPER.getElementsByTagName( 'a')[0],
			file, w, index, instansce,
			callback;
		ELM_WRAPPER.onclick = onClick;
		function draw(){
			ELM_FILENAME.className = 'file-icon-' +file.getType();
			ELM_FILENAME.innerHTML = file.getName();
		}
		function resize( index){
			ELM_WRAPPER.style.left = (index * 90) +'px';
		}
		function onClick(){
			callback( index);
			return false;
		}

		return {
			init: function( _file, _elmContainer, _index, _callback){
				instansce = this;
				if( elmContainer !== _elmContainer){
					_elmContainer.appendChild( ELM_WRAPPER);
					elmContainer = _elmContainer;
				}
				if( file !== _file){
					file = _file;
					draw();
				}
				if( index !== _index){
					index = _index;
					resize( index);
				}
				callback = _callback;
			},
			elm: ELM_WRAPPER,
			index: function( _index){
				
				return index;
			},
			onResize: function( w){
				
			},
			destroy: function(){
				elmContainer.removeChild( ELM_WRAPPER);
				file = elmContainer = null;
				BREAD_OBJECT_POOL.push( this);
			}
		}
	}
	
	var FinderClass = function( ELM_CONTAINER, tree, detailSwitchEnabled, styleSwitchEnabled, actionSwitchEnabled){
		var ICON_ARRAY = [],
			BREAD_ARRAY = [],
			elmContainer = ELM_ORIGIN_CONTAINER.cloneNode( true),
			elmLocation = elmContainer.getElementsByTagName( 'ul')[0],
			nodesDiv = elmContainer.getElementsByTagName( 'div'),
			elmSidebarButton = nodesDiv[1],
			elmStyleButton = nodesDiv[2],
			elmActionButton = nodesDiv[3],
			elmBody = nodesDiv[ nodesDiv.length -1],
			//tree = pettanr.file.createTree( TREE_TYPE),
			headX,
			headY,
			headH = pettanr.util.getElementSize( ELM_ORIGIN_FINDER_ICON).height,
			bodyY,
			currentFile = null,
			breadW = 90,
			size = pettanr.util.getElementSize( ELM_ORIGIN_FINDER_ICON),
			iconW = size.width,
			iconH = size.height,
			style = 0;
			w = 800;

		tree.addTreeEventListener( pettanr.file.TREE_EVENT.UPDATE, draw);
		
		function draw(){
			var	l = tree.hierarchy() +1,
				m = BREAD_ARRAY.length,
				_file, _bread;
			for(var i=0; i<l; ++i){
				_file = i !== l-1 ? tree.getParentFileAt( i) : tree.getCurrentFile();
				if( i < m){
					BREAD_ARRAY[ i].init( _file, elmLocation, i, onHeadClick);
				} else {
					BREAD_ARRAY.push( getBreadcrumb( _file, elmLocation, i, onHeadClick));
				}
			}
			while( l < BREAD_ARRAY.length){
				BREAD_ARRAY.pop().destroy();
			}
			
			l = _file.getChildFileLength();
			m = ICON_ARRAY.length;

			for( i=0; i<l; ++i){
				if( i < m){
					ICON_ARRAY[ i].init( _file.getChildFileByIndex( i), elmBody, w, i, style, onBodyClick);
				} else {
					ICON_ARRAY.push( getFinderIcon( _file.getChildFileByIndex( i), elmBody, w, i, style, onBodyClick));
				}
			}
			while( l < ICON_ARRAY.length){
				ICON_ARRAY.pop().destroy();
			}
		}
		function onHeadClick( i){
			var l = BREAD_ARRAY.length -1;
			if( i < l){
				var _file = tree.getParentFileAt( i);
				if( _file !== null){
					tree.up( i);
					draw();
				}
			}
		}
		function onBodyClick( i){
			var l = ICON_ARRAY.length;
			if( i < l){
				var _file = tree.getCurrentFile().getChildFileByIndex( i);
				if( _file !== null && ( _file.getChildFileLength() !== -1 || _file.getType() === pettanr.file.FILE_TYPE.FOLDER)){
					tree.down( i);
					draw();
				}
			}
		}
		
		this.init = function(){
			ELM_CONTAINER.appendChild( elmContainer);
			//$( elmLocation).click( onHeadClick);
			//$( elmContainer).click( onBodyClick);
			var position = pettanr.util.getAbsolutePosition( elmLocation);
			headX = position.x;
			headY = position.y;
			bodyY = pettanr.util.getAbsolutePosition( elmBody).y;
			delete this.init;
		}
		this.onOpen = function(){
			this.init !== undefined && this.init();
			draw();
		}
		this.onClose = function(){
			
		}
		this.onWindowResize = function( _w, _h){
				
		}
	}
	function getFinderIcon( _file, _elmContainer, w, index, style, callback){
		var _icon;
		if( FINDER_ICON_POOL.length > 0){
			_icon = FINDER_ICON_POOL.shift();
		} else {
			_icon = new FinderIconClass();
		}
		_icon.init( _file, _elmContainer, w, index, style, callback);
		return _icon;
	}
	
	function getBreadcrumb( _file, _elmContainer, index, callback){
		var _bread;
		if( BREAD_OBJECT_POOL.length > 0){
			_bread = BREAD_OBJECT_POOL.shift();
		} else {
			_bread = new BreadcrumbClass();
		}
		_bread.init( _file, _elmContainer, index, callback);
		return _bread;
	}

	return {
		init: function(){
			
		},
		createFinder: function( _elmTarget, _tree, detailSwitchEnabled, styleSwitchEnabled, actionSwitchEnabled){
			var _finder = new FinderClass( _elmTarget, _tree, detailSwitchEnabled, styleSwitchEnabled, actionSwitchEnabled);
			FINDER_ARRAY.push( _finder);
			return _finder;
		},
		createFinderHead: function(){
			
		},
		resisterFinderPane: function( _finderPane){
			
		},
		isFinderInstance: function( _finder){
			return _finder instanceof FinderClass;
		}
	}
})();


pettanr.driver = ( function(){
	var MyAuthorID = 'current_author' in window ? current_author.id : 1,
		MyArtistID = 'current_artist' in window ? current_artist.id : 1,
		Driver = {
			getSeqentialFiles: function( _file){
				var _data = FileAPI.getFileData( _file),
					_json = _data !== null ? _data.json : null;
				if( _json === true && _data.type === pettanr.driver.FILE_TYPE.COMIC ){
					_json = [ pettanr.CONST.PETTANR_ROOT_PATH, 'comics\/', _data.id, '.json\/play\/' ].join( '' );
				}
				if( typeof _json === 'string'){
					FileAPI.getJson( _file, _json, onLoadJson, onErrorJson);
					_data.state = pettanr.file.FILE_STATE.LOADING;
					_data.json = null;
					return;
				}
			},
			getName: function( _file){
				var _data = FileAPI.getFileData( _file),
					_type = _data !== null ? _data.type : null;
				if( _type === pettanr.driver.FILE_TYPE.PICTURE ){
					return [ _data.id, _data.ext ].join( '.');
				} else
				if( _type === pettanr.driver.FILE_TYPE.PANEL ){
					return [ _data.t, ':', _data.comic.title ].join( '');
				} else
				if( _type === pettanr.driver.FILE_TYPE.COMIC ){
					return _data.title;
				} else
				if( _type === pettanr.driver.FILE_TYPE.ARTIST ){
					return [ _data.id , ':', _data.name, '画伯' ].join( '');
				} else
				if( _type === pettanr.driver.FILE_TYPE.AUTHOR ){
					return [ _data.id , ':', _data.name, '先生' ].join( '');
				}
				return _data.name;
			},
			getThumbnail: function( _file){
				var _data = FileAPI.getFileData( _file);
					_type = _data !== null ? _data.type : null;
				if( _type === pettanr.driver.FILE_TYPE.PICTURE){
					return { image: [ pettanr.CONST.RESOURCE_PICTURE_PATH, 'thumbnail/', _data.id, '.', _data.ext ].join( '')};
				}
				if( _data === FILE_DATA_COMICS_ROOT){
					return { className: 'file-type-cabinet'};
				}
				if( _type === pettanr.driver.FILE_TYPE.COMIC){
					return { className: 'file-type-comic'};
				}
				if( _type === pettanr.driver.FILE_TYPE.PANEL){
					return { className: 'file-type-panel'};
				}
				if( _type === pettanr.driver.FILE_TYPE.AUTHOR){
					return { className: 'file-type-author'};
				}
				if( _type === pettanr.driver.FILE_TYPE.ARTIST){
					return { className: 'file-type-artist'};
				}
				if( _type === pettanr.driver.FILE_TYPE.FOLDEER){
					return { className: 'file-type-folder'};
				}
				return { className: 'file-type-folder'};
			}
		},
		FileAPI = pettanr.file.resisterDriver( Driver),
		FILE_DATA_SERVICE_ROOT = {
			name:		'PettanR root',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[]
		},
		FILE_DATA_COMICS_ROOT = {
			name:		'Comics',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[],
			driver:		Driver,
			json:		pettanr.CONST.URL_COMICS_JSON
		},
		FILE_DATA_PANELS_ROOT = {
			name:		'Panels',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[],
			driver:		Driver,
			json:		pettanr.CONST.URL_PANELS_JSON
		},
		FILE_DATA_PICTURE_ROOT = {
			name:		'Picutures',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[],
			driver:		Driver,
			json:		pettanr.CONST.URL_RESOURCE_PICTURES_JSON
		},
		FILE_DATA_MY_COMICS_ROOT = {
			name:		'My Comics',
			type:		pettanr.file.FILE_TYPE.AUTHOR,
			children:	[],
			driver:		Driver
		},
		FILE_DATA_MY_PICTURES_ROOT = {
			name:		'My Pictures',
			type:		pettanr.file.FILE_TYPE.ARTIST,
			children:	[],
			driver:		Driver,
			json:		pettanr.CONST.URL_ORIGINAL_PICTURES_JSON
		},
		FILE_DATA_AUTHOR_ROOT = {
			name:		'Authors',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[]
		},
		FILE_DATA_ARTIST_ROOT = {
			name:		'Artists',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[]
		},
		FILE_DATA_LISENCE_ROOT = {
			name:		'Original Lisences',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[]
		},
		FILE_DATA_BALLOON_ROOT = {
			name:		'Balloon templetes',
			type:		pettanr.file.FILE_TYPE.FOLDER,
			children:	[]
		},
		AUTHOR_ARRAY = [],
		ARTIST_ARRAY = [],
		PANEL_ARRAY = [],
		COMIC_ARRAY = [],
		RESOURCE_PICTURE_ARRAY = [],
		BALLOON_TEMPLETE_ARRAY = [],
		ORIGINAL_LICENSE_ARRAY = [],
		BASIC_LICENSES = 'cc_by,cc_nc,cc_nd,cc_sa,keep_aspect_ratio,no_convert,no_flip,no_resize'.split( ',');
	FILE_DATA_SERVICE_ROOT.children.push( FILE_DATA_COMICS_ROOT, FILE_DATA_PICTURE_ROOT, FILE_DATA_PANELS_ROOT, FILE_DATA_LISENCE_ROOT, FILE_DATA_BALLOON_ROOT);
	FILE_DATA_COMICS_ROOT.children.push( FILE_DATA_MY_COMICS_ROOT, FILE_DATA_AUTHOR_ROOT);
	FILE_DATA_PICTURE_ROOT.children.push( FILE_DATA_MY_PICTURES_ROOT, FILE_DATA_ARTIST_ROOT);
	
	FileAPI.createFolderUnderRoot( FILE_DATA_SERVICE_ROOT);

	function onLoadJson( _file, _json){
		var _access = FileAPI.getFileDataAccess( _file),
			_data = _access !== null ? _access.DATA : null,
			l;
		if( _data === null){
			onErrorJson( _file);
			return;
		}
		_data.state = pettanr.file.FILE_STATE.OK;
		
		if( Type.isArray( _json ) === true ){
			var l = _json.length;
			if( l === 0) return;
			for( var i=0; i<l; ++i ){
				buildFileData( _json[ i], _data);
			}			
		} else
		if( _json.id ){
			buildFileData( _json, _data );
		}
		_access.dispatchFileEvent( FileAPI.createFileEvent( pettanr.file.FILE_EVENT.GET_SEQENTIAL_FILES, _file, 'children', null));
	}
	function onErrorJson( _file ){ 
		var _data = FileAPI.getFileData( _file);
		if( _data !== null){
			_data.state = pettanr.file.FILE_STATE.ERROR;
		}
	}
	function buildFileData( _data, _parent ){
		var _array, i, l;
		// Panel
		if( _parent === FILE_DATA_PANELS_ROOT ){
			_data.type = pettanr.driver.FILE_TYPE.PANEL;
			_array = PANEL_ARRAY;
		} else
		// Comic
		if( _parent === FILE_DATA_COMICS_ROOT ){
			_data.type = pettanr.driver.FILE_TYPE.COMIC;
			_array = COMIC_ARRAY;
		} else
		if( _parent.type === pettanr.driver.FILE_TYPE.COMIC ){
			_array = COMIC_ARRAY;
		} else
		// Lisence
		if( _parent === FILE_DATA_LISENCE_ROOT ){
			_data.type = pettanr.driver.FILE_TYPE.LICENSE;
			_array = ORIGINAL_LICENSE_ARRAY;
		} else
		// Author
		if( _parent === FILE_DATA_AUTHOR_ROOT ){
			_data.type = pettanr.driver.FILE_TYPE.AUTHOR;
			_array = AUTHOR_ARRAY;
		} else
		// Artist
		if( _parent === FILE_DATA_ARTIST_ROOT ){
			_data.type = pettanr.driver.FILE_TYPE.ARTIST;
			_array = ARTIST_ARRAY;
		} else		
		// Picture
		if( _parent === FILE_DATA_PICTURE_ROOT || _parent === FILE_DATA_MY_PICTURES_ROOT ){
			_data.type = pettanr.driver.FILE_TYPE.PICTURE;
			_array = RESOURCE_PICTURE_ARRAY;
			// original_license を含まなければ、license object を削除して ビットデータ で保持
			// original_license なら ファイルを作る buildFileData( _license, FILE_DATA_LISENCE_ROOT)
			var _license = _data.license,
				_Math_pow = Math.pow,
				_bits = 0;
			if( typeof _license === 'object'){
				for( i=0, l=BASIC_LICENSES.length; i<l; ++i){
					if( typeof _license[ BASIC_LICENSES[ i]] === 'number'){
						_bits += _Math_pow( 2, i);
					}
				}
				_data.license = _bits;
			}
		} else {
			alert( 'error' );
		}
		
		_data.driver = Driver;
		
		// _array に _data を格納 または 上書き
		if( typeof _data.id === 'number' && _data.id > 0 ){
			var _id = _data.id - 1,
				__data = _array[ _id ],
				_reserved = pettanr.file.FILE_DATA_PROPERTY_RESERVED.join( ', ' );
			if( __data ){
				for( var key in _data){
					if( _reserved.indexOf( key ) === -1 ){
						__data[ key ] = _data[ key ];
					}
				}
				_data = __data; // このタイミングで参照が切れるので注意！！
			} else {
				_array[ _id ] = _data;
			}
		} else {
			alert( 'error' );
		}

		// Author
		// Artist
		if( _parent === FILE_DATA_AUTHOR_ROOT || _parent === FILE_DATA_ARTIST_ROOT ){
			addChildData( _parent, _data );
		} else
		// Comic + Panels
		if( _parent.type === pettanr.driver.FILE_TYPE.COMIC || _parent === FILE_DATA_COMICS_ROOT ){
			var _panels = _data.panels,
				_panel;
			if( _panels && Type.isArray( _panels ) === true ){
				
				for( i=0, l=_panels.length; i<l; ++i){
					_panel = buildFileData( _panels[ i ], FILE_DATA_PANELS_ROOT );
					/*
					 * 間違い！ t 順に格納
					 */
					addChildData( _data, _panel );
				}
				delete _data.panels;
			} else {
				if( _data.json !== null ){
					_data.json = true;
				}
				if( Type.isArray( _data.children ) === false ){
					_data.children = [];
				}				
			}
			var _author = _data.author || getResource( AUTHOR_ARRAY, _data.author_id );
			if( _author ){
				_data.author = _author = buildFileData( _author, FILE_DATA_AUTHOR_ROOT );
				addChildData( _author, _data );
				_author.id === MyAuthorID && addChildData( FILE_DATA_MY_COMICS_ROOT, _data );
			}
		} else
		// Panel
		if( _parent === FILE_DATA_PANELS_ROOT ){
			_data.comic = getResource( COMIC_ARRAY, _data.comic_id ),
			_data.author = getResource( AUTHOR_ARRAY, _data.author_id );

			// picture data をファイルに取り出し
			if( Type.isArray( _data.panel_elements ) === true ){
				var _elements,
					_elm, _rpic;
				for( i=0, l=_elements.length; i<l; ++i){
					_elm = _elements[ i];
					if( _elm.resource_picture ){
						_elm.resource_picture = buildFileData( _elm.resource_picture, FILE_DATA_PICTURE_ROOT); // 上記参照切れに備えてここで上書き
					} else {
						_elm.resource_picture = getResource( RESOURCE_PICTURE_ARRAY, _elm.resource_picture_id );
					}
				}				
			}
		} else
		// Picture
		if( _data.type = pettanr.driver.FILE_TYPE.PICTURE ){
			var _artist = _data.artist || getResource( ARTIST_ARRAY, _data.artist_id );
			if( _artist){
				_data.artist = _artist = buildFileData( _artist, FILE_DATA_ARTIST_ROOT );
				addChildData( _artist, _data );
				_artist.id === MyArtistID && addChildData( FILE_DATA_MY_PICTURES_ROOT, _data );
			}
		}
		return _data;
	}
	function addChildData( _parent, _child ){
		if( Type.isArray( _parent.children ) === false){
			_parent.children = [];
		}
		pettanr.util.getIndex( _parent.children, _child ) === -1 && _parent.children.push( _child );
	}
	function getResource( _array, _id ){
		if( Type.isArray( _array ) === false || Type.isNumber( _id ) === false || _id < 1 ) return null;
		var _data = _array[ _id - 1 ];
		if( !_data ){
			_data = _array[ _id - 1 ] = {};
		}
		return _data;
	}

	return {
		createComicTree: function(){
			return pettanr.file.createTree( FILE_DATA_SERVICE_ROOT); //FILE_DATA_COMICS_ROOT);
		},
		createPictureTree: function(){
			return pettanr.file.createTree( FILE_DATA_PICTURE_ROOT);
		},
		createServiceTree: function(){
			return pettanr.file.createTree( FILE_DATA_SERVICE_ROOT);
		},
		isPettanrFileInstance: function( _file){
			if( pettanr.file.isPettanFileInstance( _file) === true){
				var _data = FileAPI.getFileData( _file);
				return _data !== null && _data.driver === Driver;
			}
			return false;
		},
		FILE_TYPE: {
			COMIC:				FileAPI.createFileTypeID(),
			PANEL:				FileAPI.createFileTypeID(),
			PICTURE:			FileAPI.createFileTypeID(),
			PANEL_PICTURE:		FileAPI.createFileTypeID(),
			BALLOON:			FileAPI.createFileTypeID(),
			AUTHOR:				FileAPI.createFileTypeID(),
			ARTIST:				FileAPI.createFileTypeID(),
			LICENSE:			FileAPI.createFileTypeID()
		}
	}
})();


pettanr.gallery = ( function(){
	var finder,
		elmContainer = document.getElementById( 'gallery'),
		option;
		
	return {
		init: function( _option){
			option = _option;
			delete pettanr.gallery.init;
		},
		firstOpen: function(){
			finder = pettanr.finder.createFinder( elmContainer, pettanr.driver.createPictureTree());
			delete pettanr.gallery.firstOpen;
		},
		onOpen: function(){
			pettanr.gallery.firstOpen !== undefined && pettanr.gallery.firstOpen();
			finder.onOpen();
			
		},
		onClose: function(){
			finder.onClose();
		},
		onWindowResize: function( _w, _h){
			finder.onWindowResize( _w, _h);
		}
	}
})();

pettanr.cabinet = ( function(){
	var finder,
		elmContainer = document.getElementById( 'cabinet'),
		option;
		
	return {
		init: function( _option){
			option = _option;
			delete pettanr.cabinet.init;
		},
		firstOpen: function(){
			finder = pettanr.finder.createFinder( elmContainer, pettanr.driver.createComicTree());
			delete pettanr.cabinet.firstOpen;
		},
		onOpen: function(){
			pettanr.cabinet.firstOpen !== undefined && pettanr.cabinet.firstOpen();
			finder.onOpen();
			
		},
		onClose: function(){
			finder.onClose();
		},
		onWindowResize: function( _w, _h){
			finder.onWindowResize( _w, _h);
		}
	}
})();

// i18n
// login
// lib

pettanr.fn( pettanr.view);
pettanr.fn( pettanr.overlay);
pettanr.fn( pettanr.key);
pettanr.fn( pettanr.balloon);

pettanr.fn( pettanr.editor);
pettanr.fn( pettanr.comicConsole);
pettanr.fn( pettanr.uploadConsole);
pettanr.fn( pettanr.panelConsole);
pettanr.fn( pettanr.artistConsole);

pettanr.fn( pettanr.file);
pettanr.fn( pettanr.finder);
pettanr.fn( pettanr.gallery);
pettanr.fn( pettanr.cabinet);

$(window).ready( pettanr.init);
