require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe ArtistsController do

  # This should return the minimal set of attributes required to create a valid
  # Artist. As you add validations to Artist, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all artists as @artists" do
      artist = Artist.create! valid_attributes
      get :index
      assigns(:artists).should eq([artist])
    end
  end

  describe "GET show" do
    it "assigns the requested artist as @artist" do
      artist = Artist.create! valid_attributes
      get :show, :id => artist.id
      assigns(:artist).should eq(artist)
    end
  end

  describe "GET new" do
    it "assigns a new artist as @artist" do
      get :new
      assigns(:artist).should be_a_new(Artist)
    end
  end

  describe "GET edit" do
    it "assigns the requested artist as @artist" do
      artist = Artist.create! valid_attributes
      get :edit, :id => artist.id
      assigns(:artist).should eq(artist)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Artist" do
        expect {
          post :create, :artist => valid_attributes
        }.to change(Artist, :count).by(1)
      end

      it "assigns a newly created artist as @artist" do
        post :create, :artist => valid_attributes
        assigns(:artist).should be_a(Artist)
        assigns(:artist).should be_persisted
      end

      it "redirects to the created artist" do
        post :create, :artist => valid_attributes
        response.should redirect_to(Artist.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved artist as @artist" do
        # Trigger the behavior that occurs when invalid params are submitted
        Artist.any_instance.stub(:save).and_return(false)
        post :create, :artist => {}
        assigns(:artist).should be_a_new(Artist)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Artist.any_instance.stub(:save).and_return(false)
        post :create, :artist => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested artist" do
        artist = Artist.create! valid_attributes
        # Assuming there are no other artists in the database, this
        # specifies that the Artist created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Artist.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => artist.id, :artist => {'these' => 'params'}
      end

      it "assigns the requested artist as @artist" do
        artist = Artist.create! valid_attributes
        put :update, :id => artist.id, :artist => valid_attributes
        assigns(:artist).should eq(artist)
      end

      it "redirects to the artist" do
        artist = Artist.create! valid_attributes
        put :update, :id => artist.id, :artist => valid_attributes
        response.should redirect_to(artist)
      end
    end

    describe "with invalid params" do
      it "assigns the artist as @artist" do
        artist = Artist.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Artist.any_instance.stub(:save).and_return(false)
        put :update, :id => artist.id, :artist => {}
        assigns(:artist).should eq(artist)
      end

      it "re-renders the 'edit' template" do
        artist = Artist.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Artist.any_instance.stub(:save).and_return(false)
        put :update, :id => artist.id, :artist => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested artist" do
      artist = Artist.create! valid_attributes
      expect {
        delete :destroy, :id => artist.id
      }.to change(Artist, :count).by(-1)
    end

    it "redirects to the artists list" do
      artist = Artist.create! valid_attributes
      delete :destroy, :id => artist.id
      response.should redirect_to(artists_url)
    end
  end

end
