require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe BaloonTypesController do

  # This should return the minimal set of attributes required to create a valid
  # BaloonType. As you add validations to BaloonType, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all baloon_types as @baloon_types" do
      baloon_type = BaloonType.create! valid_attributes
      get :index
      assigns(:baloon_types).should eq([baloon_type])
    end
  end

  describe "GET show" do
    it "assigns the requested baloon_type as @baloon_type" do
      baloon_type = BaloonType.create! valid_attributes
      get :show, :id => baloon_type.id
      assigns(:baloon_type).should eq(baloon_type)
    end
  end

  describe "GET new" do
    it "assigns a new baloon_type as @baloon_type" do
      get :new
      assigns(:baloon_type).should be_a_new(BaloonType)
    end
  end

  describe "GET edit" do
    it "assigns the requested baloon_type as @baloon_type" do
      baloon_type = BaloonType.create! valid_attributes
      get :edit, :id => baloon_type.id
      assigns(:baloon_type).should eq(baloon_type)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new BaloonType" do
        expect {
          post :create, :baloon_type => valid_attributes
        }.to change(BaloonType, :count).by(1)
      end

      it "assigns a newly created baloon_type as @baloon_type" do
        post :create, :baloon_type => valid_attributes
        assigns(:baloon_type).should be_a(BaloonType)
        assigns(:baloon_type).should be_persisted
      end

      it "redirects to the created baloon_type" do
        post :create, :baloon_type => valid_attributes
        response.should redirect_to(BaloonType.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved baloon_type as @baloon_type" do
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonType.any_instance.stub(:save).and_return(false)
        post :create, :baloon_type => {}
        assigns(:baloon_type).should be_a_new(BaloonType)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonType.any_instance.stub(:save).and_return(false)
        post :create, :baloon_type => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested baloon_type" do
        baloon_type = BaloonType.create! valid_attributes
        # Assuming there are no other baloon_types in the database, this
        # specifies that the BaloonType created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        BaloonType.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => baloon_type.id, :baloon_type => {'these' => 'params'}
      end

      it "assigns the requested baloon_type as @baloon_type" do
        baloon_type = BaloonType.create! valid_attributes
        put :update, :id => baloon_type.id, :baloon_type => valid_attributes
        assigns(:baloon_type).should eq(baloon_type)
      end

      it "redirects to the baloon_type" do
        baloon_type = BaloonType.create! valid_attributes
        put :update, :id => baloon_type.id, :baloon_type => valid_attributes
        response.should redirect_to(baloon_type)
      end
    end

    describe "with invalid params" do
      it "assigns the baloon_type as @baloon_type" do
        baloon_type = BaloonType.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonType.any_instance.stub(:save).and_return(false)
        put :update, :id => baloon_type.id, :baloon_type => {}
        assigns(:baloon_type).should eq(baloon_type)
      end

      it "re-renders the 'edit' template" do
        baloon_type = BaloonType.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        BaloonType.any_instance.stub(:save).and_return(false)
        put :update, :id => baloon_type.id, :baloon_type => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested baloon_type" do
      baloon_type = BaloonType.create! valid_attributes
      expect {
        delete :destroy, :id => baloon_type.id
      }.to change(BaloonType, :count).by(-1)
    end

    it "redirects to the baloon_types list" do
      baloon_type = BaloonType.create! valid_attributes
      delete :destroy, :id => baloon_type.id
      response.should redirect_to(baloon_types_url)
    end
  end

end
